/*								Csocket.cpp: Csocket class

	This file is not distributed under the GNU public license (I dont know what that is anyway), 
	it is absolutely free.
	As long as you are maintainig some note that you stole this code from me, you are allowed to use it.

	derDoc																		derDoc@gmx.net
																		members.xoom.com/derDoc
*/

#include "stdafx.h"

#include "Csocket.h"
#include "selbst.h"






    Csocket::Csocket(HWND hwnd, UINT Msg)
	{
		WSADATA wsd;
		
		bWSAstarted = true;
		s = 0;
		Hwnd = hwnd;
        uMsg = Msg;
		bConnected = false;
		bListening = false;
		bUdp=false;
				
		if (WSAStartup(MAKEWORD(2,0),&wsd)) bWSAstarted = false;
	}


	Csocket::~Csocket()
	{
		if (bConnected)	shutdown(s,SD_BOTH);
		  		
		closesocket(s);

		WSACleanup();
	
	}


	
	void Csocket::setSocket(SOCKET newS)
	{
		s = newS;
		bConnected = true;
		
		return;
	}

	void Csocket::setIP(char *IP)
	{
		strcpy(connIP, IP);
	
		return;
	}


	char *Csocket::getIP(char *ret)
	{

		strcpy(ret, connIP);
		return (ret);
	}
	
	
	int Csocket::connect(char *IP, short port, bool Udp)
	{
        HOSTENT FAR *he;
		struct sockaddr_in sa;
		int iError;
		int i;
		bUdp=Udp;

		s = socket(AF_INET,(Udp ? SOCK_DGRAM : SOCK_STREAM),(Udp ? IPPROTO_UDP:IPPROTO_TCP));      //get socket
		if (s==INVALID_SOCKET) return NO_SOCK;              //invalid?

		//switch socket to nonblocking-mode:
		
		WSAAsyncSelect(s,Hwnd, uMsg, FD_READ|FD_CONNECT|FD_WRITE|FD_ACCEPT);
		
		sa.sin_family = AF_INET;          //type: Internet
		sa.sin_port = htons(port);        //htons = host2network byte order(little Endian) 
		if ((sa.sin_addr.S_un.S_addr = inet_addr(IP)) == INADDR_NONE){  //true -> *IP's a host name
				
			if (!(he = gethostbyname(IP))) return NO_VADDR;            //not a valid adress
			memcpy((char *)&sa.sin_addr, he->h_addr, he->h_length);    //ip from hostname
			strcpy(connIP, inet_ntoa(sa.sin_addr));   //network byte order (ulong)IP to string
			strcpy(IP, connIP);   //back to IP
			

		}else
			strcpy(connIP, IP);    //*IP's a string like *.*.*.*; copy to connIP          
			


		
		iError = ::connect(s,(struct sockaddr *) &sa, sizeof(sa)); 
			
		if ((iError==SOCKET_ERROR) && (i = WSAGetLastError()) != WSAEWOULDBLOCK){
			switch(i)
			{
			case WSAECONNREFUSED:
				return CONN_REFUSED;
			
			case WSAEHOSTUNREACH:
			case WSAEHOSTDOWN:
			case WSAETIMEDOUT:
			case WSAENETDOWN:
				return HOST_UNREACHABLE;

			}
		}

		

		bConnected = true;
		return G_OK;
	}
	
	
	int Csocket::listen(short *port,bool Udp)
	{

		struct sockaddr_in sa;
		bUdp=Udp;
	
		s = socket(AF_INET,(Udp ? SOCK_DGRAM : SOCK_STREAM),(Udp ? IPPROTO_UDP:IPPROTO_TCP));      //get socket
		if (s==INVALID_SOCKET) return NO_SOCK;

		WSAAsyncSelect(s,Hwnd, uMsg, FD_READ|FD_CONNECT|FD_WRITE|FD_ACCEPT);
		
		sa.sin_family = AF_INET;
		sa.sin_port = htons(*port);
		sa.sin_addr.S_un.S_addr = ADDR_ANY;
		
		
		
		if (!bind(s,(struct sockaddr *) &sa, sizeof(sa))) {

			if (!(*port)){
				struct sockaddr_in sazero;
				int sizeeof=sizeof(sazero);
				getsockname(s,(struct sockaddr *)&sazero,&sizeeof);
				*port=ntohs(sazero.sin_port);
			}

			
			if (Udp || !(::listen(s, SOMAXCONN)))

			{
				bListening = true;
				return G_OK;
			}
		}
		return PORT_USED;
	}


	CsocketPtr Csocket::accept(void)
	{
         struct sockaddr_in sa;
         SOCKET newSock;
		 int size;
		 CsocketPtr csock;

		 size = sizeof(sa);

		 newSock = ::accept(s, (struct sockaddr *) &sa, &size);
		 if (newSock == INVALID_SOCKET) return NULL;

		 (CsocketPtr) csock = new Csocket((HWND)Hwnd, uMsg);

		 csock->setSocket(newSock);
		 if (size) csock->setIP(inet_ntoa((struct in_addr)sa.sin_addr));
		 

		 return (csock);
	}




	int Csocket::send(LPVOID pData, int len, struct sockaddr_in *san)
	{
		int i,j;
	
		if (!bConnected && bUdp)
			 i = ::sendto(s, (char FAR *) pData, len, 0, (const struct sockaddr *)san, sizeof(*san));

		else i = ::send(s, (char FAR *) pData, len, 0);

		if ((i == SOCKET_ERROR) && ((j=WSAGetLastError()) != WSAEWOULDBLOCK)) return 0;  
		


		return (i);
	}
		 


	LPVOID Csocket::receive(int *len,struct sockaddr_in *san)
	{

		int size=sizeof(*san);
		int actLen = 0;
		int temp,i,j=0;
		if (bUdp) i=2048;
		else i=512;

		char *pLen = (char *)malloc(i);
		LPVOID pBuff = malloc(i);
		

		if (bUdp){
			
			if (((actLen = recvfrom(s, (char FAR *) pBuff, i, 0,(struct sockaddr FAR*)san,&size))==SOCKET_ERROR)&&
				(WSAGetLastError()==WSAEWOULDBLOCK)) return NULL;

		}else{				
				
			while (((temp = recv(s, (char FAR *) pLen, i, 0)) != SOCKET_ERROR) && (temp)) 
			{	
			
				memcpy(((char *)pBuff + actLen), pLen, temp);
				
				if (j<5){
					j++;
					pBuff = realloc(pBuff, ((actLen += temp) + i));
				}else{ i=2048;
					pLen =(char*) realloc((LPVOID)pLen,i);
					pBuff = realloc(pBuff, ((actLen += temp) + i));
				}
			}
			
		}
		
		free(pLen);
		//i=WSAGetLastError();
		
		if (actLen == 0) return NULL;
		*len = actLen;
		return pBuff;
		
	}



		

	bool Csocket::disconnect(void)
	{

		int iError;
		
		iError = shutdown(s,SD_BOTH);
		if (iError == WSAEINPROGRESS) return false;
		closesocket(s);
		bConnected = false;
		bListening = false;
		return true;
	}



	bool Csocket::deListen(void)
	{
		
		if (bConnected) disconnect();
		else {
			closesocket(s);
			bListening = false;
		}
		
		return true;
	}


	bool Csocket::testConn(void)
	{

		if (bUdp) return true;

		timeval tv = {0,0};
		fd_set fd;
		int ret,i;
		char *pBuff = (char *)malloc(16);

		FD_ZERO(&fd);
		FD_SET(s, &fd);
		
		ret = select(0,NULL,&fd,NULL, &tv);
		if (ret == 0 || ret == SOCKET_ERROR) return false;

		ret = select(0, &fd,NULL,NULL, &tv);
		if (ret == SOCKET_ERROR) return false;

		if ((ret==1) && ((i=recv(s, pBuff, 16, MSG_PEEK)) <= 0)) return false;   


		return true;

	}


/*	char *Csocket::IP2Name(void)
	{

		HOSTENT *he; 
		int i;
		
		if (!(he = gethostbyaddr((const char *)inet_addr(connIP), sizeof(struct in_addr), AF_INET)))

			i= WSAGetLastError();
		
		if (he) return (he->h_name);
		return NULL;
	
	}
*/




	


		 





	
	 